#include "stdafx.h"
#include <conio.h>
#include "EventLogClient.h"
#include "EventLogProvider.h"
#pragma warning(push)
#pragma warning(disable : 6001 26451 26461 26477 26485 26486 26493 26486 26489 26494)
#include "EventLogDemo.h"
#pragma warning(pop)


void PrintEvent(EVT_HANDLE hEvent)
{
  //The EvtRenderEventXml flag tells EvtRender to render the event as an XML string.
  DWORD dwBufferSize{0};
  DWORD dwBufferUsed{0};
  DWORD dwPropertyCount{0};
  if (!EvtRender(nullptr, hEvent, EvtRenderEventXml, dwBufferSize, nullptr, &dwBufferUsed, &dwPropertyCount))
  {
#pragma warning(suppress: 26477)
    ATLASSUME(GetLastError() == ERROR_INSUFFICIENT_BUFFER);
    dwBufferSize = dwBufferUsed;
    std::vector<wchar_t> szRenderedContent{dwBufferSize, std::allocator<wchar_t>{}};
#pragma warning(suppress: 26477 26486)
    ATLVERIFY(EvtRender(nullptr, hEvent, EvtRenderEventXml, dwBufferSize, szRenderedContent.data(), &dwBufferUsed, &dwPropertyCount));
#pragma warning(suppress: 26486)
    wprintf(L"Rendered message: %s\n", szRenderedContent.data());
  }
}

#pragma warning(suppress: 26812)
DWORD WINAPI SubscribeCallback(EVT_SUBSCRIBE_NOTIFY_ACTION /*Action*/, PVOID /*UserContext*/, EVT_HANDLE Event)
{
  EventLog::CSession s;
  EventLog::CPublisher pub{s.OpenPublisher(L"Microsoft-Windows-UAC", nullptr)};
  std::wstring sValue;
  EventLog::CEvent evt{Event};
  if (pub.FormatMessage(evt, 0, 0, nullptr, EvtFormatMessageEvent, sValue))
    wprintf(L"Formatted message: %s\n", sValue.c_str());
  evt.Detach();

  return 0;
}


int _tmain()
{
#ifdef _AFX
  //Initialise MFC
  if (!AfxWinInit(GetModuleHandle(nullptr), nullptr, GetCommandLine(), SW_SHOW))
    return 1;
#endif //#ifdef _AFX

  //Test out the CHandle class
  EVT_HANDLE h;
#pragma warning(suppress: 26490)
  h = reinterpret_cast<EVT_HANDLE>(42);
  EventLog::CHandle h1{h};
  h1.Attach(h1.Detach());
  EventLog::CHandle h2{h1.Detach()};
  h2.Cancel();
  h = h2; //NOLINT(clang-analyzer-deadcode.DeadStores)
  EventLog::CHandle h3;

  //Test out the CSession class
  EventLog::CSession s1;
  EventLog::CPublisherEnumerator enum1{s1.OpenPublisherEnum()};
  EventLog::CSession s2{s1.Detach()};
  EventLog::CSession s3{s2.Detach()};
  std::wstring sProvider;
  while (enum1.Next(sProvider))
    wprintf(L"Found provider %s\n", sProvider.c_str());
  EventLog::CPublisher pub{s1.OpenPublisher(L"Microsoft-Windows-HttpService", nullptr)};
  EventLog::CPublisher pub2{pub.Detach()};
  DWORD dwBufferSize{0};
  pub2.GetProperty(EvtPublisherMetadataMessageFilePath, 0, 0, nullptr, &dwBufferSize);
#pragma warning(suppress: 26477)
  ATLASSUME(GetLastError() == ERROR_INSUFFICIENT_BUFFER);
  std::vector<BYTE> property{dwBufferSize, std::allocator<BYTE>{}};
#pragma warning(suppress: 26489 26490)
  auto pVariant{reinterpret_cast<PEVT_VARIANT>(property.data())};
#pragma warning(suppress: 26477 26486)
  ATLVERIFY(pub2.GetProperty(EvtPublisherMetadataMessageFilePath, 0, dwBufferSize, pVariant, &dwBufferSize));
  EventLog::CEventEnumerator enumEvents{pub2.EnumEvents()};
  BOOL bContinue{TRUE};
  while (bContinue)
  {
    EventLog::CEventMetaData evt1{enumEvents.Next()};
    bContinue = (evt1 != nullptr);
    if (bContinue)
    {
      const BOOL bSuccess{evt1.GetProperty(EventMetadataEventID, 0, 0, nullptr, &dwBufferSize)};
      UNREFERENCED_PARAMETER(bSuccess);
#pragma warning(suppress: 26477)
      ATLASSUME(GetLastError() == ERROR_INSUFFICIENT_BUFFER);
      std::vector<BYTE> property3{dwBufferSize, std::allocator<BYTE>{}};
#pragma warning(suppress: 26489 26490)
      auto pVariant3{reinterpret_cast<PEVT_VARIANT>(property3.data())};
#pragma warning(suppress: 26477 26486)
      ATLVERIFY(evt1.GetProperty(EventMetadataEventID, 0, dwBufferSize, pVariant3, &dwBufferSize));
    }
  }

  EventLog::CChannelEnumerator enumChan{s3.OpenChannelEnum()};
  std::wstring sChannel;
  while (enumChan.Next(sChannel))
    wprintf(L"Found channel %s\n", sChannel.c_str());

  //Test out the CBookmark class
  EventLog::CBookmark b1;
  BOOL bSuccess{b1.Create(nullptr)};
  UNREFERENCED_PARAMETER(bSuccess);

  //Test out the CResultSet class
  _tprintf(_T("Enumerating entries in the \"Microsoft-Windows-UAC/Operational\" event log\n"));
  EventLog::CResultSet set1{s3.Query(L"Microsoft-Windows-UAC/Operational", nullptr, EvtQueryChannelPath | EvtQueryForwardDirection)};
  bSuccess = set1.GetInfo(EvtQueryNames, 0, nullptr, &dwBufferSize); //NOLINT(clang-analyzer-deadcode.DeadStores)
  bContinue = TRUE;
  int nEvents{0};
  while (bContinue)
  {
    EventLog::CEvent event;
    DWORD dwReturned{0};
    bContinue = set1.Next(1, &event.m_h, INFINITE, 0, &dwReturned);
    if (bContinue)
    {
      ++nEvents;
      UNREFERENCED_PARAMETER(nEvents);
      PrintEvent(event);

      bSuccess = event.GetInfo(EvtEventPath, 0, nullptr, &dwBufferSize); //NOLINT(clang-analyzer-deadcode.DeadStores)
      bSuccess = set1.Seek(0, nullptr, 0, EvtSeekRelativeToCurrent); //NOLINT(clang-analyzer-deadcode.DeadStores)

      //if (nEvents == 3)
      //  bSuccess = b1.Update(event);

      EventLog::CPublisher pub4{s3.OpenPublisher(L"Microsoft-Windows-UAC", nullptr)};
#pragma warning(suppress: 26489)
      std::wstring sValue;
      if (pub4.FormatMessage(event, 0, 0, nullptr, EvtFormatMessageEvent, sValue))
      {
        wprintf(L"Formatted message: %s\n", sValue.c_str());
      }

      //if (nEvents == 5)
      //{
      //  bSuccess = set1.Seek(-2, b1, 0, EvtSeekRelativeToBookmark);
      //}
    }
  }

  EventLog::CResultSet set2{s3.Query(L"Microsoft-Windows-UACXXXX/Operational", L"<xml>./xxxxml>", EvtQueryChannelPath | EvtQueryForwardDirection)};
  std::wstring sStatus;
  bSuccess = EventLog::GetExtendedStatus(sStatus); //NOLINT(clang-analyzer-deadcode.DeadStores)

  _tprintf(_T("Subscribing to entries in the \"Microsoft-Windows-UAC/Operational\" event log. Hit any key to quit\n"));
  EventLog::CResultSet set3{s3.Subscribe(nullptr, L"Microsoft-Windows-UAC/Operational", nullptr, nullptr, nullptr, SubscribeCallback, EvtSubscribeStartAtOldestRecord)};
  while (!_kbhit())
    Sleep(10);


  bSuccess = s3.ExportLog(L"Microsoft-Windows-UAC/Operational", nullptr, L"c:\\temp\\UAC.evt", EvtExportLogChannelPath); //NOLINT(clang-analyzer-deadcode.DeadStores)
  bSuccess = s3.ArchiveExportedLog(L"c:\\temp\\UAC.evt", 0); //NOLINT(clang-analyzer-deadcode.DeadStores)

  EventLog::CHandle log{s3.OpenLog(L"c:\\temp\\uac.evt", EvtOpenFilePath)};

  bSuccess = s3.ClearLog(L"Microsoft-Windows-UAC/Operational", nullptr); //NOLINT(clang-analyzer-deadcode.DeadStores)

  EventLog::CChannelConfig channelConfig{s3.OpenChannelConfig(L"Microsoft-Windows-UAC/Operational")};
  channelConfig.Attach(channelConfig.Detach());
  channelConfig.GetProperty(EvtChannelConfigEnabled, 0, 0, nullptr, &dwBufferSize);
#pragma warning(suppress: 26477)
  ATLASSUME(GetLastError() == ERROR_INSUFFICIENT_BUFFER);
  std::vector<BYTE> property2{dwBufferSize, std::allocator<BYTE>{}};
#pragma warning(suppress: 26489 26490)
  auto pVariant2{reinterpret_cast<PEVT_VARIANT>(property2.data())};
#pragma warning(suppress: 26486 26477)
  ATLVERIFY(channelConfig.GetProperty(EvtChannelConfigEnabled, 0, dwBufferSize, pVariant2, &dwBufferSize));

#pragma warning(suppress: 26486)
  bSuccess = channelConfig.SetProperty(EvtChannelConfigEnabled, 0, pVariant2); //NOLINT(clang-analyzer-deadcode.DeadStores)
  bSuccess = channelConfig.Save(); //NOLINT(clang-analyzer-deadcode.DeadStores)

  _tprintf(_T("Enumerating entries in the \"Microsoft-Windows-User Profile Service/Operational\" event log (ten at a time)\n"));
  EventLog::CResultSet set4{s3.Query(L"Microsoft-Windows-User Profile Service/Operational", nullptr, EvtQueryChannelPath | EvtQueryForwardDirection)};
  bContinue = TRUE;
  std::vector<EventLog::CEvent> events{10, std::allocator<EventLog::CEvent>{}};
  while (bContinue)
  {
    DWORD dwReturned{0};
    bContinue = set4.Next(events, INFINITE, 0, &dwReturned);
    if (bContinue)
    {
      for (DWORD i{0}; i<dwReturned; i++)
#pragma warning(suppress: 26446)
        PrintEvent(events[i]);
    }
  }

  //Test out the CLog class
  EventLog::CLog log2{s1.OpenLog(L"Microsoft-Windows-UAC/Operational", EvtOpenChannelPath)};
  log2.GetInfo(EvtLogNumberOfLogRecords, 0, nullptr, &dwBufferSize);
#pragma warning(suppress: 26477)
  ATLASSUME(GetLastError() == ERROR_INSUFFICIENT_BUFFER);
  std::vector<BYTE> property3{dwBufferSize, std::allocator<BYTE>{}};
#pragma warning(suppress: 26490)
  pVariant = reinterpret_cast<PEVT_VARIANT>(property3.data());
#pragma warning(suppress: 26477)
  ATLVERIFY(log2.GetInfo(EvtLogNumberOfLogRecords, dwBufferSize, pVariant, &dwBufferSize));


  //Test out the event log provider
  EventLog::CProvider provider;
  EventLog::CProvider provider2;
  provider2 = provider.Detach();
#pragma warning(suppress: 26477)
  ATLVERIFY(provider.Register(&EVENTLOGDEMO_EVENTLOG_PROVIDER) == ERROR_SUCCESS); //NOLINT(clang-diagnostic-unused-value)
  provider.Attach(provider.Detach());

  BOOLEAN bEnabled{provider.EventEnabled(&EVENT_1)}; //NOLINT(clang-analyzer-deadcode.DeadStores, clang-diagnostic-unused-but-set-variable)
  bEnabled = provider.Enabled(1, 0); //NOLINT(clang-analyzer-deadcode.DeadStores)

  //ULONG nError{provider.Write(&demoEvent1, 0, nullptr)};
  //UNREFERENCED_PARAMETER(nError);
  //nError = provider.Write(&demoEvent2, 0, nullptr);

  //GUID EventLogWrappersDemoActivity1{0x52f5842d, 0x3061, 0x442b, {0xbc, 0xf4, 0xe9, 0x78, 0x7b, 0xe5, 0xc, 0x5e }};
  //nError = EventActivityIdControl(EVENT_ACTIVITY_CTRL_CREATE_ID, &EventLogWrappersDemoActivity1);
  //nError = provider.WriteTransfer(&demoEvent2, nullptr, &EventLogWrappersDemoActivity1, 0, nullptr);
  //nError = provider.Write(0, 0, L"Mary had a little lamb");

  EventLog::CProvider provider3{provider.Detach()};
  const REGHANDLE hHandle{provider3};
  UNREFERENCED_PARAMETER(hHandle);


  EventRegisterNAUGHTER_EVENTLOGDEMO();
  for (int i{0}; i<10; i++)
  {
    EventWriteEVENT_1();
    EventWriteEVENT_2(L"Fox");
    EventWriteEVENT_3(L"Goose");
    EventWriteEVENT_4(L"Chicken");
  }
  EventUnregisterNAUGHTER_EVENTLOGDEMO();

  return 0;
}
